// mkcal.cpp		ver.0.02
//copyright 2016 Beer[Tsutsumi Hiroyuki]

#include	"mkcal.h"

#define	VER		"ver.0.02"
#define	DATE	"2016. 2.11"

int main(int argc,char **argv)
{
	if((argc!=1)&&(argc!=3)){printf("mkcal "VER"\nusage :\n\tmkcal\t\t\t\t: config mode\n\tmkcal config_file output_file\t: create mode\n");exit(1);}

	if(!(tr=BTranslatorRoster::Default()))return(1);

	time_t		current;
	struct tm	*loctime;
	current=time(0);
	loctime=localtime(&current);
	now_y=loctime->tm_year+1900;
	now_m=loctime->tm_mon+1;
	now_d=loctime->tm_mday;
	now_w=loctime->tm_wday;
//printf("today=%d/%d/%d (%d)\n",now_y,now_m,now_d,now_w);

	mkcal	app(argc,argv);
	if(argc==1)app.Run();
	return(0);
}
//------------------------------------------------
mkcal::mkcal(int argc,char **argv):BApplication("application/x-vnd.Beer-mkcal")
{
	fp=NULL;
	get_translator_for_output();
	get_fonts();
	scrn=BScreen().Frame();
//printf("scrn=%d %d %d %d\n",(int)scrn.left,(int)scrn.top,(int)scrn.right,(int)scrn.bottom);
	v=new mkcalview(scrn);

	if(argc==3){	//output only
//printf("mkcal_const outputonly\n");
		entry_ref	eref;
		get_ref_for_path(argv[1],&eref);
		v->load_config(eref);
		v->create_wallpaper();
		BEntry	e(argv[2]);
		entry_ref	dir;
		char	name[B_FILE_NAME_LENGTH];
		e.GetName(name);
		e.GetParent(&e);
		e.GetRef(&dir);
		v->save(dir,name);
		if(autoset){
			v->set_wallpaper(argv[2]);
			rgb_color	rgb;
			rgb.red=scrn_color>>16;rgb.green=scrn_color>>8;rgb.blue=scrn_color;
			BScreen().SetDesktopColor(rgb);
		}
	}else{			//set config
#if	B_BEOS_VERSION>=0x0520
		app_info	ai;	be_app->GetAppInfo(&ai);
		BPath	ap(&ai.ref),dp;
		ap.GetParent(&dp);
		BPath	lp(dp);
		lp.Append("Language/Dictionaries");
		lp.Append("mkcal");
		be_locale.LoadLanguageFile(lp.Path());
#endif
		pw=new prevwindow(BRect(10,30,scrn.Width()-420,scrn.Height()-10));
		cw=new configwindow(BRect(scrn.Width()-400,scrn.Height()-400,scrn.Width(),scrn.Height()));
	}

	delete v;
}

mkcal::~mkcal()
{
	if(fp)delete fp;
	object	*ob;
	for(int i=0;ob=(object*)obl.ItemAt(i);i++)delete ob;
	xlator	*xl;
	for(int i=0;xl=(xlator*)xlt.ItemAt(i);i++)delete xl;
	font	*f;
	for(int i=0;f=(font*)fontl.ItemAt(i);i++)delete f;
}

void mkcal::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"mkcal "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.eonet.ne.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
}

void mkcal::get_translator_for_output()
{
	BBitmap 			*tbm=new BBitmap(BRect(0,0,7,7),B_RGB_32_BIT);
	BBitmapStream		*instrm=new BBitmapStream(tbm);
	translator_info		*inf;
	const translation_format	*frm;
	int32				infs,frms;
	tr->GetTranslators(instrm,NULL,&inf,&infs);
	for(int i=0;i<infs;i++){
		tr->GetOutputFormats(inf[i].translator,&frm,&frms);
		for(int j=0;j<frms;j++){
//printf("%c%c%c%c %4.2f %4.2f\n",frm[j].type>>24,frm[j].type>>16,frm[j].type>>8,frm[j].type,frm[j].quality,frm[j].capability);
			if(frm[j].type=='bits')continue;		//standard bitmap
			if(frm[j].type=='mhi!')continue;		//progressive bitmap
			xlator	*xl=new xlator;
			xl->type=frm[j].type;
			xl->id=inf[i].translator;
			strcpy(xl->name,frm[j].name);
			strcpy(xl->mime,frm[j].MIME);
			if(frm[j].type=='TGA ')xlt.AddItem((void*)xl,0);else xlt.AddItem((void*)xl);
			trc++;
		}
	}
	delete inf;
}

void mkcal::get_fonts()
{
	font	ftd;
	be_plain_font->GetFamilyAndStyle(&ftd.fam,&ftd.sty);

	font_family	fontf;
	font_style	fonts;

	int	no=0;
	int fc=count_font_families();
	for(int i=0;i<fc;i++){
		get_font_family(i,&fontf);
		int sc=count_font_styles(fontf);
		for(int j=0;j<sc;j++){
			get_font_style(fontf,j,&fonts);
			font	*f=new font;
			strcpy(f->fam,fontf);
			strcpy(f->sty,fonts);
			fontl.AddItem((void*)f);
			if((!strcmp(fontf,ftd.fam))&&(!strcmp(fonts,ftd.sty)))dfn=no;
			no++;
		}
	}
}
//------------------------------------------------
mkcalview::mkcalview(BRect frame):BView(frame,"mkcalview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	bimg=NULL;
	clr_obj();
	bm=new BBitmap(scrn,B_RGB_32_BIT,true);			//gousei
}

mkcalview::~mkcalview()
{
	clr_obj();
	if(bimg)delete bimg;								//bimg-img
	if(bm)delete bm;
}

void mkcalview::draw_cal()
{
//printf("draw_cal\n");
	char	s[32];
	uchar	r,g,b,a;
	SetViewColor(0,0,0);
	font_height	fh;

	float	vl,vt,vr,vb;
	float	vw,vh,mw,mh;
/*
	if(IsPrinting()){
		vl=Bounds().left;vt=Bounds().top;vr=Bounds().right;vb=Bounds().bottom;
		vw=Bounds().Width();
		vh=Bounds().Height();
	}else{
		vl=pic.left;vt=pic.top;vr=pic.right;vb=pic.bottom;
		vw=pic.Width();
		vh=pic.Height();
	}
//	mw=vw/6;
//	mh=mw;
*/

object	*o;
for(int i=0;o=(object*)obl.ItemAt(i);i++){
//printf("draw object no=%d\n",i);
	int	year=now_y;
	int	month=now_m;
	int	day=now_d;

	vl=o->r.left;vt=o->r.top;vr=o->r.right;vb=o->r.bottom;

	if(o->bgtype==0){	//fill_background
		SetDrawingMode(B_OP_ALPHA);
		r=o->bgcolor>>16;g=o->bgcolor>>8;b=o->bgcolor;a=o->bgcolor>>24;
		SetHighColor(r,g,b,a);
		FillRect(o->r);
		SetDrawingMode(B_OP_COPY);
	}

	if(o->type==0){			//1day
		day+=o->when;adj(&year,&month,&day);
		mw=o->r.Width();	mh=o->r.Height();

		if(o->bgtype==1){	//bubble_background
			SetDrawingMode(B_OP_ALPHA);
			r=o->bgcolor>>16;g=o->bgcolor>>8;b=o->bgcolor;a=o->bgcolor>>24;
			SetHighColor(r,g,b,a);
			FillRoundRect(BRect(vl,vt,vl+mw-1,vt+mh-1),mh/4,mh/4);
			SetDrawingMode(B_OP_COPY);
		}

		BFont	fm;
		fm.SetFamilyAndStyle(o->day_fontf,o->day_fonts);
		fm.SetSize(o->day_size>0?o->day_size:(mw/15<mh?mw/15:mh));
		SetFont(&fm);
		fm.GetHeight(&fh);
		int	h1=(int)(fh.ascent+fh.descent);
		r=o->day_color>>16;g=o->day_color>>8;b=o->day_color;
		SetHighColor(r,g,b);r=(r>>1)+0x40;g=(g>>1)+0x40;b=(b>>1)+0x40;SetLowColor(r,g,b);
		int	x,y,z;
		if(what_day(year,month,day,&y,&x,&z))break;z=z%100;
		char const youbi[7][4]={"sun","mon","tue","wed","thu","fri","sat"};
		sprintf(s,"%d/%d/%d(%s)",year,month,day,youbi[x]);
		int	fw=(int)fm.StringWidth(s);
		if(z){
			DrawString(s,BPoint(vl+mw/2-fw/2,vt+mh/4+h1/2-fh.descent));
			strcpy(s,holyday_name[z<20?z-1:z-6]);
			fw=(int)fm.StringWidth(s);
			DrawString(s,BPoint(vl+mw/2-fw/2,vt+mh*3/4+h1/2-fh.descent));
		}else{
			DrawString(s,BPoint(vl+mw/2-fw/2,vt+mh/2+h1/2-fh.descent));
		}
	}						//1day_end

	if(o->type==10){		//1month(block)
		month+=o->when;adj(&year,&month,&day);
		mw=o->r.Width();	mh=o->r.Height();

		if(o->year_type>=0){
			BFont	fy;
			fy.SetFamilyAndStyle(o->year_fontf,o->year_fonts);
			fy.SetSize(o->year_size>0?o->year_size:mw/(15+o->year_type*3));
			SetFont(&fy);
			fy.GetHeight(&fh);
			int	h0=(int)(fh.ascent+fh.descent);
//			sprintf(s,"%d",year);
			strcpy(s,ystr(year,o->year_type));
			int	fw=(int)fy.StringWidth(s);
			if(o->bgtype==1){	//bubble_background
				SetDrawingMode(B_OP_ALPHA);
				r=o->bgcolor>>16;g=o->bgcolor>>8;b=o->bgcolor;a=o->bgcolor>>24;
				SetHighColor(r,g,b,a);
				FillRoundRect(BRect(vl+h0/2,vt,vl+h0/2+fw,vt+h0),h0/4,h0/4);
				SetDrawingMode(B_OP_COPY);
			}
			r=o->year_color>>16;g=o->year_color>>8;b=o->year_color;
			SetHighColor(r,g,b);r=(r>>1)+0x40;g=(g>>1)+0x40;b=(b>>1)+0x40;SetLowColor(r,g,b);
			DrawString(s,BPoint(vl+h0/2,vt+fh.ascent));
		}

		if(o->month_type>=0){
			BFont	fm;
			fm.SetFamilyAndStyle(o->month_fontf,o->month_fonts);
			fm.SetSize(o->month_size>0?o->month_size:mh/8);
			SetFont(&fm);
			fm.GetHeight(&fh);
			int	h1=(int)(fh.ascent+fh.descent);
			strcpy(s,month_name[o->month_type*12+month-1]);
			int	fw=(int)fm.StringWidth(s);
			if(o->bgtype==1){	//bubble_background
				SetDrawingMode(B_OP_ALPHA);
				r=o->bgcolor>>16;g=o->bgcolor>>8;b=o->bgcolor;a=o->bgcolor>>24;
				SetHighColor(r,g,b,a);
				FillRoundRect(BRect(vl+mw/2-fw/2-h1/2,vt,vl+mw/2+fw/2+h1/2,vt+h1),h1/4,h1/4);
				SetDrawingMode(B_OP_COPY);
			}
			r=o->month_color>>16;g=o->month_color>>8;b=o->month_color;
			SetHighColor(r,g,b);r=(r>>1)+0x40;g=(g>>1)+0x40;b=(b>>1)+0x40;SetLowColor(r,g,b);
			DrawString(s,BPoint(vl+mw/2-fw/2,vt+fh.ascent));
		}

		BFont	fd;
		fd.SetFamilyAndStyle(o->day_fontf,o->day_fonts);
		fd.SetSize(o->day_size?o->day_size:mh/10);
		SetFont(&fd);
		fd.GetHeight(&fh);
		int	h2=(int)(fh.ascent+fh.descent);
		for(int d=1;d<=31;d++){
			int	x,y,z;
			if(what_day(year,month,d,&y,&x,&z))break;
			if(o->today_deco<0)z=z%100;
			uint32	fc,bc;
			if(z%100)fc=o->hol_color;
			else if(x==0)fc=o->sun_color;
			else if(x==6)fc=o->sat_color;
			else fc=o->day_color;
			if(o->bgtype==1)bc=o->bgcolor;//else bc=0;
			if(z>99){
				if(o->today_deco==0){	//today(color)
					fc=o->today_color;
					z-=100;
				}
				if(o->today_deco==1){	//today(reverse)
					if(o->bgtype==0){
						r=fc>>16;g=fc>>8;b=fc;
						SetHighColor(r,g,b);
						FillRect(BRect(vl+mw*(x+0.5)/8+mw/80,vt+mh/8*(y+1.5)+mh/80,vl+mw*(x+1.5)/8-mw/80,vt+mh/8*(y+2.5)-mh/80));
					}else{
						bc=fc|0xff000000;
					}
					fc=o->today_color;	//fc=o->bgcolor;
					z-=100;
				}
			}
			if(o->bgtype==1){	//bubble_background
				SetDrawingMode(B_OP_ALPHA);
				r=bc>>16;g=bc>>8;b=bc;a=bc>>24;
				SetHighColor(r,g,b,a);
				FillRoundRect(BRect(vl+mw*(x+0.5)/8+mw/80,vt+mh/8*(y+1.5)+mh/80,vl+mw*(x+1.5)/8-mw/80,vt+mh/8*(y+2.5)-mh/80),mh/32,mh/32);
				SetDrawingMode(B_OP_COPY);
			}
			if(z>99){					//today(circle)
				r=o->today_color>>16;g=o->today_color>>8;b=o->today_color;
				SetHighColor(r,g,b);SetPenSize(3);
				StrokeEllipse(BRect(vl+mw*(x+0.5)/8+mw/80,vt+mh/8*(y+1.5)+mh/80,vl+mw*(x+1.5)/8-mw/80,vt+mh/8*(y+2.5)-mh/80));
			}
			r=fc>>16;g=fc>>8;b=fc;
			SetHighColor(r,g,b);r=(r>>1)+0x40;g=(g>>1)+0x40;b=(b>>1)+0x40;SetLowColor(r,g,b);
			sprintf(s,"%d",d);
			int	fw=(int)fd.StringWidth(s);
			DrawString(s,BPoint(vl+mw*(x+1)/8-fw/2,vt+mh/8*(y+2)+h2/2-fh.descent));
		}

	}				//1month(block)_end

	if(o->type==20){		//12months(yoko)
		year+=o->when;adj(&year,&month,&day);
		mw=o->r.Width();	mh=o->r.Height();

		if(o->bgtype==1){	//bubble_background
			SetDrawingMode(B_OP_ALPHA);
			r=o->bgcolor>>16;g=o->bgcolor>>8;b=o->bgcolor;a=o->bgcolor>>24;
			SetHighColor(r,g,b,a);
			for(int m=0;m<12;m++){
				int	mx,my;
				my=m/6;mx=m-my*6;
				mx=(int)(mx*mw/6);my=(int)(my*mh/2);
				FillRoundRect(BRect(vl+mx+mw/120,vt+my+mh/50,vl+mx+mw/6-mw/120,vt+my+mh/2-mh/50),mh/15,mh/15);
			}
			SetDrawingMode(B_OP_COPY);
		}

		BFont	fy;
		fy.SetFamilyAndStyle(o->year_fontf,o->year_fonts);
		fy.SetSize(o->year_size>0?o->year_size:mw/50);
		SetFont(&fy);
		fy.GetHeight(&fh);
		int	h0=(int)(fh.ascent+fh.descent);
		r=o->year_color>>16;g=o->year_color>>8;b=o->year_color;
		SetHighColor(r,g,b);r=(r>>1)+0x40;g=(g>>1)+0x40;b=(b>>1)+0x40;SetLowColor(r,g,b);
		sprintf(s,"%d",year);
		DrawString(s,BPoint(vl+h0/2,vt+h0));

		BFont	fm;
		fm.SetFamilyAndStyle(o->month_fontf,o->month_fonts);
		fm.SetSize(o->month_size>0?o->month_size:mh/16);
		SetFont(&fm);
		fm.GetHeight(&fh);
		int	h1=(int)(fh.ascent+fh.descent);
		r=o->month_color>>16;g=o->month_color>>8;b=o->month_color;
		SetHighColor(r,g,b);r=(r>>1)+0x40;g=(g>>1)+0x40;b=(b>>1)+0x40;SetLowColor(r,g,b);
		for(int m=0;m<12;m++){
			sprintf(s,"%d",m+1);
			int	fw=(int)fm.StringWidth(s);
			int	mx,my;
			my=m/6;mx=m-my*6;
			mx=(int)(mx*mw/6);my=(int)(my*mh/2);
			DrawString(s,BPoint(vl+mx+mw/12-fw/2,vt+my+h1));
		}

		BFont	fd;
		fd.SetFamilyAndStyle(o->day_fontf,o->day_fonts);
		fd.SetSize(o->day_size>0?o->day_size:mw/60);
		SetFont(&fd);
		fd.GetHeight(&fh);
		int	h2=(int)(fh.ascent+fh.descent);
		for(int m=1;m<=12;m++){
			int	mx,my;
			my=(m-1)/6;mx=(m-1)-my*6;
			mx=(int)(mx*mw/6);my=(int)(my*mh/2);
			for(int d=1;d<=31;d++){
				int	x,y,z;
				if(what_day(year,m,d,&y,&x,&z))break;

				if(o->today_deco<0)z=z%100;
				uint32	fc;
				if(z%100)fc=o->hol_color;
				else if(x==0)fc=o->sun_color;
				else if(x==6)fc=o->sat_color;
				else fc=o->day_color;
				if(z>99){
					if(o->today_deco==0){	//today(color)
						fc=o->today_color;
					}
					if(o->today_deco==1){	//today(reverse)
						if((o->bgtype==0)||(o->bgtype==1)){
							r=fc>>16;g=fc>>8;b=fc;
							SetHighColor(r,g,b);
							FillRect(BRect(vl+mx+mw*(x+0.5)/48,vt+my+mh/16*(y+2),vl+mx+mw*(x+1.5)/48,vt+my+mh/16*(y+3)));
						}
						fc=o->today_color;	//fc=o->bgcolor;
					}
					if(o->today_deco==2){	//today(circle)
						r=o->today_color>>16;g=o->today_color>>8;b=o->today_color;
						SetHighColor(r,g,b);SetPenSize(3);
						StrokeEllipse(BRect(vl+mx+mw*(x+0.5)/48,vt+my+mh/16*(y+2),vl+mx+mw*(x+1.5)/48,vt+my+mh/16*(y+3)));
					}
				}
				r=fc>>16;g=fc>>8;b=fc;
				SetHighColor(r,g,b);r=(r>>1)+0x40;g=(g>>1)+0x40;b=(b>>1)+0x40;SetLowColor(r,g,b);
				sprintf(s,"%d",d);
				int	fw=(int)fd.StringWidth(s);
				DrawString(s,BPoint(vl+mx+mw*(x+1)/48-fw/2,vt+my+mh/16*(y+2.5)+h2/2-fh.descent));
			}
		}
	}				//12months_end
}
}

void mkcalview::adj(int *year,int *month,int *day)
{
	const int	days1[12]={31,28,31,30,31,30,31,31,30,31,30,31};
	const int	days2[12]={31,29,31,30,31,30,31,31,30,31,30,31};
	while(1){
		if(*month<1){			//kyonen
			*month+=12;(*year)--;
		}else if(*month>12){	//rainen
			*month-=12;(*year)++;
		}else if(*day<1){		//sengetsu
			(*month)--;if(*month<1){*month+=12;(*year)--;}
			*day+=((*year%4)?days1[*month-1]:days2[*month-1]);
		}else if((*year%4==0)&&(*day>days2[*month-1])){	//raigetsu(uruudoshi)
			*day-=days2[*month-1];(*month)++;
		}else if((*year%4==0)&&(*day>days1[*month-1])){	//raigetsu(heinen)
			*day-=days1[*month-1];(*month)++;
		}else break;
	}
}

int mkcalview::what_day(int year,int month,int day,int *w,int *d,int *z)
{
	static int	xxx[12]={0,31,59,90,120,151,181,212,243,273,304,334};
	int	syun=(int)(20.69115+(year-2000)*0.2421904-(int)((year-2000)/4));
	int	syuu=(int)(23.09+(year-2000)*0.2421904-(int)((year-2000)/4));

	int	stt=0;
	if((year<2001)||(year>2099))stt=1;
	if((month<1)||(month>12))stt=2;
	if((day<1)||(day>31))stt=3;
	if(month==2){
		if(year%4){
			if(day>28)stt=3;
		}else{
			if(day>29)stt=3;
		}
	}else if((month==4)||(month==6)||(month==9)||(month==11)){
		if(day>30)stt=3;
	}
	int	week=(day+6)/7;
	if(stt){
		*w=-1;*d=-1;*z=-1;
	}else{
		int	c=1+(year-2001)*365+(year-2001)/4;
		c+=xxx[month-1];
		if(((year%4)==0)&&(month>2))c++;
		*w=((c%7)+(day-1))/7;	//syuu
		*d=(c+day-1)%7;			//youbi

		*z=0;
		if((month==1)&&(day==1))*z=1;				//ganjitsu
		if((month==1)&&(week==2)&&(*d==1))*z=2;		//seijin_no_hi
		if((month==2)&&(day==11))*z=3;				//kenkokukinen_no_hi
		if((month==3)&&(day==syun))*z=4;			//syunbun_no_hi(futei)
		if((month==4)&&(day==29))*z=5;				//shouwa_no_hi
		if((month==5)&&(day==3))*z=6;				//kenpou_kinenbi
		if((month==5)&&(day==4))*z=7;				//midori_no_hi
		if((month==5)&&(day==5))*z=8;				//kodomo_no_hi
		if((month==7)&&(week==3)&&(*d==1))*z=9;		//umi_no_hi
		if((month==8)&&(day==11))*z=10;				//yama_no_hi
		if((month==9)&&(week==3)&&(*d==1))*z=11;	//keirou_no_hi
		if((month==9)&&(day==syuu))*z=12;			//syuubun_no_hi(futei)
		if((month==10)&&(week==2)&&(*d==1))*z=13;	//taiiku_no_hi
		if((month==11)&&(day==3))*z=14;				//bunka_no_hi
		if((month==11)&&(day==23))*z=15;			//kinroukansya_no_hi
		if((month==12)&&(day==23))*z=16;			//tennnou_tanjyoubi
//furikaekyuujitsu
		if((*z==0)&&(*d!=0))for(int bf=day-1;;bf--){
			int	t1,t2,t3;
			if(what_day(year,month,bf,&t1,&t2,&t3))break;
			if(t3>99)t3-=100;
			if((t3==0)||(t3>19))break;
			if(t2==0){*z=21;break;}
		}
//kokuminnokyuujitsu
		if((*z==0)&&(month==9)&&(day<23)&&(day==syuu-1)&&(*d==2))*z=22;		//kani_hantei
//today
		if((year==now_y)&&(month==now_m)&&(day==now_d))*z+=100;
	}
	return(stt);
}

char* mkcalview::ystr(int year,int type)
{
	const char	kansu[]="〇一二三四五六七八九十";
	static char	s[16];
	*s=0;
	if(type==0)sprintf(s,"%d",year);	//seireki
	if(type==1){						//seireki-kanji
		strncpy(s,kansu+(int)(year/1000)*3,3);year=year%1000;
		strncpy(s+3,kansu+(int)(year/100)*3,3);year=year%100;
		strncpy(s+6,kansu+(int)(year/10)*3,3);year=year%10;
		strncpy(s+9,kansu+year*3,3);
		*(s+12)=0;
	}
	if((type==2)&&(year>1988)){			//gengo
		char	*sp=s;
		strncpy(sp,"平成",6);sp+=6;year-=1988;
		if(year>19){strncpy(sp,kansu+(int)(year/10)*3,3);sp+=3;}
		if(year>9){strncpy(sp,kansu+10*3,3);sp+=3;year=year%10;}
		if(year){strncpy(sp,kansu+year*3,3);sp+=3;}
		strncpy(sp,"年",3);sp+=3;
		*sp=0;
	}
	return(s);
}

void mkcalview::load(entry_ref &eref)
{
//printf("load img\n");
	BFile	*rf=new BFile(&eref,B_READ_ONLY);
	if(bimg){delete bimg;bimg=NULL;}
	BBitmapStream	outstrm;
	if(!tr->Translate(rf,NULL,NULL,&outstrm,B_TRANSLATOR_BITMAP)){
		outstrm.DetachBitmap(&bimg);
		BPath	bp;
		BEntry(&eref).GetPath(&bp);
		strcpy(baseimgpath,bp.Path());
//printf("load img ok\n");
	}
	delete	rf;
}

void mkcalview::save(entry_ref &dir,char *name)
{
	BBitmap	*bmout=new BBitmap(scrn,B_RGB_32_BIT);
	memcpy(bmout->Bits(),bm->Bits(),bmout->BitsLength());

//printf("output_format > no=%d:%s\n",outfmt,((xlator*)xlt.ItemAt(outfmt))->name);
	BFile	*wf=new BFile();
	BDirectory(&dir).CreateFile(name,wf,false);

	BBitmapStream	instrm(bmout);
	tr->Translate(&instrm,NULL,NULL,wf,((xlator*)xlt.ItemAt(outfmt))->type);
//	instrm.DetachBitmap(&bmout);

	BAppFileInfo	wfi(wf);
	wfi.SetType(((xlator*)xlt.ItemAt(outfmt))->mime);
	delete	wf;
}

void mkcalview::clr_obj()
{
	object	*o;
	for(int i=0;o=(object*)obl.ItemAt(i);i++)delete o;
	obl.MakeEmpty();
	sel_now.f=false;
	sel_no=-1;
	if(bimg){delete bimg;bimg=NULL;}
	*baseimgpath=0;
	base_mode=1;
	base_color=0x336699;
	bg_bounds=scrn;
	autoset=false;
	textback=true;
	scrn_color=0x336699;

//select_format
	outfmt=0;
	for(int i=0;i<trc;i++){
//		printf("mime=%s\n",((xlator*)xlt.ItemAt(i))->mime);
//		printf("name=%s\n",((xlator*)xlt.ItemAt(i))->name);
		if(strstr(((xlator*)xlt.ItemAt(i))->mime,"png")){outfmt=i;break;}
	}
//printf("output_format > no=%d:%s\n",outfmt,((xlator*)xlt.ItemAt(outfmt))->name);
}

void mkcalview::load_config(entry_ref &eref)
{
	BPath	bp;
	BEntry(&eref).GetPath(&bp);
//printf("load_config : [%s]\n",bp.Path());
	FILE	*fp;
	if(fp=fopen(bp.Path(),"r")){	//load
		clr_obj();
		object	*o=new object();
		char	s[256],*s1,*s2,*s3;		//s1[256],s2[256];
		while(fgets(s,256,fp)){
			if(*s<'A')continue;
			for(s1=s;(uchar)*s1>' ';s1++);*s1=0;while((uchar)*(++s1)<=' ');
//printf("str=[%s] str1=[%s]\n",s,s1);

			if(!strcmp(s,"base_type")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("base_type=%d\n",d);
				base_mode=d;
			}
			if(!strcmp(s,"base_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("base_color=%08x\n",x);
				base_color=x;
			}
			if(!strcmp(s,"base_image")){
				for(s2=s1;(uchar)*s2>=' ';s2++);*s2=0;
//printf("load_base_image : [%s]\n",s1);
				//load base_image
				entry_ref	im_eref;
				get_ref_for_path(s1,&im_eref);
				load(im_eref);
			}
			if(!strcmp(s,"image_bounds")){
				int	l,t,r,b;
				sscanf(s1,"%d,%d,%d,%d",&l,&t,&r,&b);
//printf("image_bounds=(%d,%d,%d,%d)\n",l,t,r,b);
				bg_bounds=BRect(l,t,r,b);
			}
			if(!strcmp(s,"out_format")){
				for(s2=s1;(uchar)*s2>=' ';s2++);*s2=0;
//printf("out_format=[%s]\n",s1);
				xlator	*xl;
				for(int i=0;xl=(xlator*)xlt.ItemAt(i);i++){
					if(!strcmp(xl->mime,s1)){outfmt=i;break;}
				}
			}
			if(!strcmp(s,"wp_autoset")){
				bool	f;
				f=(*s1=='y')||(*s1=='Y');
//printf("wp_autoset=%c\n",f?'y':'n');
				autoset=f;
			}
			if(!strcmp(s,"wp_textback")){
				bool	f;
				f=(*s1=='y')||(*s1=='Y');
//printf("wp_textback=%c\n",f?'y':'n');
				textback=f;
			}
			if(!strcmp(s,"screen_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("screen_color=%08x\n",x);
				scrn_color=x;
			}

			if(!strcmp(s,"bounds")){
				int	l,t,r,b;
				sscanf(s1,"%d,%d,%d,%d",&l,&t,&r,&b);
//printf("bounds=(%d,%d,%d,%d)\n",l,t,r,b);
				o->r=BRect(l,t,r,b);
				obl.AddItem(o);
				o=new object(o);
			}
			if(!strcmp(s,"type")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("type=%d\n",d);
				o->type=d;
			}
			if(!strcmp(s,"when")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("when=%d\n",d);
				o->when=d;
			}
			if(!strcmp(s,"bg_type")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("bg_type=%d\n",d);
				o->bgtype=d;
			}
			if(!strcmp(s,"bg_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("bg_color=%08x\n",x);
				o->bgcolor=x;
			}
			if(!strcmp(s,"year_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("year_color=%08x\n",x);
				o->year_color=x;
			}
			if(!strcmp(s,"month_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("month_color=%08x\n",x);
				o->month_color=x;
			}
			if(!strcmp(s,"day_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("day_color=%08x\n",x);
				o->day_color=x;
			}
			if(!strcmp(s,"sun_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("sun_color=%08x\n",x);
				o->sun_color=x;
			}
			if(!strcmp(s,"sat_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("sat_color=%08x\n",x);
				o->sat_color=x;
			}
			if(!strcmp(s,"hol_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("hol_color=%08x\n",x);
				o->hol_color=x;
			}
			if(!strcmp(s,"today_color")){
				uint32	x;
				sscanf(s1,"%8x",&x);
//printf("today_color=%08x\n",x);
				o->today_color=x;
			}
			if(!strcmp(s,"year_size")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("year_size=%d\n",d);
				o->year_size=d;
			}
			if(!strcmp(s,"month_size")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("month_size=%d\n",d);
				o->month_size=d;
			}
/*
			if(!strcmp(s,"week_size")){
				int	d;
				sscanf(s1,"%d",&d);
printf("week_size=%d\n",d);
				o->week_size=d;
			}
*/
			if(!strcmp(s,"day_size")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("day_size=%d\n",d);
				o->day_size=d;
			}
			if(!strcmp(s,"year_type")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("year_type=%d\n",d);
				o->year_type=d;
			}
			if(!strcmp(s,"month_type")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("month_type=%d\n",d);
				o->month_type=d;
			}
			if(!strcmp(s,"today_mark")){
				int	d;
				sscanf(s1,"%d",&d);
//printf("today_mark=%d\n",d);
				o->today_deco=d;
			}

			if(!strcmp(s,"year_font")){
				for(s2=s1;(uchar)*s2>=' ';s2++)if(*s2==',')break;*(s2++)=0;
				for(s3=s2;(uchar)*s3>=' ';s3++);*s3=0;
//printf("year_font=[%s]-[%s]\n",s1,s2);
				strcpy(o->year_fontf,s1);
				strcpy(o->year_fonts,s2);
				font	*f;
				for(int i=0;f=(font*)fontl.ItemAt(i);i++){
					if((!strcmp(f->fam,s1))&&(!strcmp(f->sty,s2))){o->year_font=i;break;}
				}
			}
			if(!strcmp(s,"month_font")){
				for(s2=s1;(uchar)*s2>=' ';s2++)if(*s2==',')break;*(s2++)=0;
				for(s3=s2;(uchar)*s3>=' ';s3++);*s3=0;
//printf("month_font=[%s]-[%s]\n",s1,s2);
				strcpy(o->month_fontf,s1);
				strcpy(o->month_fonts,s2);
				font	*f;
				for(int i=0;f=(font*)fontl.ItemAt(i);i++){
					if((!strcmp(f->fam,s1))&&(!strcmp(f->sty,s2))){o->month_font=i;break;}
				}
			}
			if(!strcmp(s,"day_font")){
				for(s2=s1;(uchar)*s2>=' ';s2++)if(*s2==',')break;*(s2++)=0;
				for(s3=s2;(uchar)*s3>=' ';s3++);*s3=0;
//printf("day_font=[%s]-[%s]\n",s1,s2);
				strcpy(o->day_fontf,s1);
				strcpy(o->day_fonts,s2);
				font	*f;
				for(int i=0;f=(font*)fontl.ItemAt(i);i++){
					if((!strcmp(f->fam,s1))&&(!strcmp(f->sty,s2))){o->day_font=i;break;}
				}
			}
		}

		delete o;
		fclose(fp);
	}else{														//not found(use default)
		printf("not found config_file. use default\n");
	}
}

void mkcalview::save_config(entry_ref &dir,const char *name)
{
	BPath	bp;
	BEntry(&dir).GetPath(&bp);
	bp.Append(name);
//printf("save_config : [%s]\n",bp.Path());
	FILE	*fp;
	if(fp=fopen(bp.Path(),"w")){	//save
		fprintf(fp,"base_type\t%d\n",base_mode);
		fprintf(fp,"base_color\t%08x\n",base_color);
		if(*baseimgpath)fprintf(fp,"base_image\t%s\n",baseimgpath);
		fprintf(fp,"image_bounds\t%d,%d,%d,%d\n",(int)bg_bounds.left,(int)bg_bounds.top,(int)bg_bounds.right,(int)bg_bounds.bottom);
		if(outfmt>=0)fprintf(fp,"out_format\t%s\n",((xlator*)xlt.ItemAt(outfmt))->mime);
		fprintf(fp,"wp_autoset\t%c\n",autoset?'y':'n');
		fprintf(fp,"wp_textback\t%c\n",textback?'y':'n');
		fprintf(fp,"screen_color\t%08x\n",scrn_color);
		object	*o;
		for(int i=0;o=(object*)obl.ItemAt(i);i++){
			fprintf(fp,"\n");
			fprintf(fp,"type\t%d\n",o->type);
			fprintf(fp,"when\t%d\n",o->when);
			fprintf(fp,"bg_type\t%d\n",o->bgtype);
			fprintf(fp,"bg_color\t%08x\n",o->bgcolor);
			fprintf(fp,"year_color\t%08x\n",o->year_color);
			fprintf(fp,"month_color\t%08x\n",o->month_color);
			fprintf(fp,"day_color\t%08x\n",o->day_color);
			fprintf(fp,"sun_color\t%08x\n",o->sun_color);
			fprintf(fp,"sat_color\t%08x\n",o->sat_color);
			fprintf(fp,"hol_color\t%08x\n",o->hol_color);
			fprintf(fp,"today_color\t%08x\n",o->today_color);
			fprintf(fp,"year_size\t%d\n",o->year_size);
			fprintf(fp,"month_size\t%d\n",o->month_size);
			fprintf(fp,"day_size\t%d\n",o->day_size);
			fprintf(fp,"year_type\t%d\n",o->year_type);
			fprintf(fp,"month_type\t%d\n",o->month_type);
			fprintf(fp,"today_mark\t%d\n",o->today_deco);
			fprintf(fp,"year_font\t%s,%s\n",o->year_fontf,o->year_fonts);
			fprintf(fp,"month_font\t%s,%s\n",o->month_fontf,o->month_fonts);
			fprintf(fp,"day_font\t%s,%s\n",o->day_fontf,o->day_fonts);
			fprintf(fp,"bounds\t%d,%d,%d,%d\n",(int)o->r.left,(int)o->r.top,(int)o->r.right,(int)o->r.bottom);
		}

		fclose(fp);
	}
}

void mkcalview::create_wallpaper()
{
	uchar	r,g,b;
	r=base_color>>16;g=base_color>>8;b=base_color;
	SetHighColor(r,g,b);
	bm->Lock();
	bm->AddChild(this);
	FillRect(scrn);
	if((bimg)&&(base_mode)){
		BRect	p;
		if(base_mode==1)p=scrn;
		if(base_mode==2){
			int	sw=scrn.IntegerWidth();
			int	sh=scrn.IntegerHeight();
			int	w=bimg->Bounds().IntegerWidth();
			int	h=bimg->Bounds().IntegerHeight();
			p=BRect((sw-w)/2,(sh-h)/2,(sw+w)/2-1,(sh+h)/2-1);
		}
		if(base_mode==3)p=bg_bounds;
//printf("scrn %dx%d  img=%dx%d   > %d,%d,%d,%d\n",sw,sh,w,h,(int)p.left,(int)p.top,(int)p.right,(int)p.bottom);
		DrawBitmap(bimg,p);
	}
	draw_cal();
	Sync();
	bm->RemoveChild(this);
	bm->Unlock();
}

void mkcalview::set_wallpaper(char *path)
{
	BNode	n("/boot/home/Desktop");
	BMessage	m;
	m.AddInt32(B_BACKGROUND_WORKSPACES,1);
	m.AddString(B_BACKGROUND_IMAGE,path);
	m.AddInt32(B_BACKGROUND_MODE,B_BACKGROUND_MODE_CENTERED);
	m.AddPoint(B_BACKGROUND_ORIGIN,BPoint(0,0));
	m.AddBool(B_BACKGROUND_ERASE_TEXT,textback);
	int		size=m.FlattenedSize();
	char	*buf=new char[size];
	m.Flatten(buf,size);
	n.WriteAttr(B_BACKGROUND_INFO,B_MESSAGE_TYPE,0,buf,size);
	delete buf;
	BMessenger("application/x-vnd.Be-TRAK").SendMessage(B_RESTORE_BACKGROUND_IMAGE);
}
//------------------------------------------------
prevwindow::prevwindow(BRect frame):BWindow(frame,"mkcal preview",B_DOCUMENT_WINDOW,0)
{
	BRect	vframe,sbvframe,sbhframe;

	vframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH,frame.Height()-B_H_SCROLL_BAR_HEIGHT);//
	v=new preview(vframe);
	AddChild(v);

	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,frame.Height()-B_H_SCROLL_BAR_HEIGHT+1);//
	sbvframe.OffsetTo(frame.Width()-B_V_SCROLL_BAR_WIDTH+1,0);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);

	sbhframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH+1,B_H_SCROLL_BAR_HEIGHT);//
	sbhframe.OffsetTo(0,frame.Height()-B_H_SCROLL_BAR_HEIGHT+1);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);

 	SetSizeLimits(199,scrn.Width()+B_V_SCROLL_BAR_WIDTH,119,scrn.Height()+B_H_SCROLL_BAR_HEIGHT);
	FrameResized(frame.Width(),frame.Height());
	Show();
}

bool prevwindow::QuitRequested()
{
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);
	return(true);
}

void prevwindow::Zoom(BPoint rec_position,float rec_width,float rec_height)
{
	static BRect	winr;
	BRect	fsr(0,0,scrn.Width()+B_V_SCROLL_BAR_WIDTH,scrn.Height()+B_H_SCROLL_BAR_HEIGHT);
	if(Bounds()==fsr){
		ResizeTo(winr.Width(),winr.Height());
		MoveTo(winr.LeftTop());
	}else{							//fullscreen
		winr=Frame();
		MoveTo(0,0);
		ResizeTo(fsr.Width(),fsr.Height());
	}
}

void prevwindow::FrameResized(float width,float height)
{
	float	rv,rh;
	rv=scrn.Height()-sbv->Bounds().Height()+1;
	rh=scrn.Width()-sbh->Bounds().Width()+1;
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
	sbv->SetProportion(sbv->Bounds().Height()/scrn.Height());
	sbh->SetProportion(sbh->Bounds().Width()/scrn.Width());
	sbv->SetSteps(5,sbv->Bounds().Height());
	sbh->SetSteps(5,sbh->Bounds().Width());
}
//------------------------------------------------
preview::preview(BRect frame):BView(frame,"preview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	mv=new mkcalview(scrn);
	mv->create_wallpaper();

	mf=0;
	sel_old.f=sel_now.f=false;
	sel_no=-1;
}

preview::~preview()
{
	delete mv;
}

void preview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(0,0,0);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
}

void preview::Draw(BRect rect)
{
//printf("draw: w=%d h=%d\n",rect.IntegerWidth(),rect.IntegerHeight());
	if(IsPrinting()){
//printf("print: w=%d h=%d\n",Bounds().IntegerWidth(),Bounds().IntegerHeight());
	}else{
//printf("screen: w=%d h=%d\n",Bounds().IntegerWidth(),Bounds().IntegerHeight());
	}

//printf("mkcal:preview:Draw\n");
	eraseframe();
	DrawBitmap(mv->bm,rect,rect);
	drawframe();
	if((*baseimgpath==0)&&(obl.CountItems()==0)){
		SetFontSize(30);
		DrawString("mkcal",BPoint(45,50));
		SetFontSize(20);
		DrawString(VER,BPoint(75,80));
	}
}

void preview::MouseDown(BPoint pt)
{
	BPoint	p;uint32	b;	GetMouse(&p,&b);
	if(b==B_SECONDARY_MOUSE_BUTTON){Window()->Zoom();return;}
	
	int	old=sel_no;
	mpt=pt;
	mf=0;
	if(sel_no>=0){
		mf=0;
		BRect	ir=((object*)obl.ItemAt(sel_no))->r;
		if(ir.Contains(pt))mf=-1;
		BRect	r;
		r.Set(ir.left-3,ir.top-3,ir.left+3,ir.top+3);
		if(r.Contains(pt))mf=1;
		r.Set(ir.right-3,ir.top-3,ir.right+3,ir.top+3);
		if(r.Contains(pt))mf=2;
		r.Set(ir.left-3,ir.bottom-3,ir.left+3,ir.bottom+3);
		if(r.Contains(pt))mf=3;
		r.Set(ir.right-3,ir.bottom-3,ir.right+3,ir.bottom+3);
		if(r.Contains(pt))mf=4;
		if(mf==0)sel_no=-1;
	}
	if(sel_no<0){
		object	*o;
		for(int i=0;o=(object*)obl.ItemAt(i);i++){
			if(o->r.Contains(pt))sel_no=i;
		}
	}

	if(sel_no!=old){
		BMessage	*m=new BMessage('Preq');
		m->AddInt8("edit_no",sel_no);
		BMessenger(((mkcal*)be_app)->cw->v).SendMessage(m);
	}
}

void preview::MouseUp(BPoint pt)
{
	if(mf){
		object	*o=(object*)obl.ItemAt(sel_no);
		int	l=(int)sel_now.r.left;
		int	t=(int)sel_now.r.top;
		int	r=(int)sel_now.r.right;
		int	b=(int)sel_now.r.bottom;
		if(l>r){int x=l;l=r;r=x;}
		if(t>b){int	y=t;t=b;b=y;}
		o->r=BRect(l,t,r,b);
		eraseframe();drawframe();

		BMessage	*m=new BMessage('Preq');
		m->AddInt8("edit_no",sel_no);
		BMessenger(((mkcal*)be_app)->cw->v).SendMessage(m);
	}
	mf=0;
}

void preview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
	if(mf){
		int	dx=(int)(pt.x-mpt.x);
		int	dy=(int)(pt.y-mpt.y);
		object	*o=(object*)obl.ItemAt(sel_no);

		BRect	r=o->r;
		if(mf==-1)sel_now.r=BRect(r.left+dx,r.top+dy,r.right+dx,r.bottom+dy);
		if(mf==1)sel_now.r=BRect(r.left+dx,r.top+dy,r.right,r.bottom);
		if(mf==2)sel_now.r=BRect(r.left,r.top+dy,r.right+dx,r.bottom);
		if(mf==3)sel_now.r=BRect(r.left+dx,r.top,r.right,r.bottom+dy);
		if(mf==4)sel_now.r=BRect(r.left,r.top,r.right+dx,r.bottom+dy);
		eraseframe();drawframe();
	}
}

void preview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
/*
		case 'fipr':{				//printout
			if(bm){
				BPrintJob	prt("mkcal");
				prt.ConfigPage();
				prt.ConfigJob();
				BRect		pr=prt.PrintableRect();
				prt.BeginJob();
				prt.DrawView(this,pr,BPoint(0,0));
				prt.SpoolPage();
				prt.CommitJob();
			}
		}break;
*/
		case 'aclr':{				//all clear
			mv->clr_obj();
			BMessage	*m=new BMessage('Preq');
			m->AddInt8("edit_no",-1);
			BMessenger(((mkcal*)be_app)->cw->v).SendMessage(m);
		}break;
		case 'rcfg':{				//load config
			delete fp;fp=NULL;
			entry_ref	eref;
			msg->FindRef("refs",&eref);
			mv->load_config(eref);
			BMessage	*m=new BMessage('Preq');
			m->AddInt8("edit_no",-1);
			BMessenger(((mkcal*)be_app)->cw->v).SendMessage(m);
		}break;
		case 'rimg':{				//load image
			delete fp;fp=NULL;
			entry_ref	eref;
			msg->FindRef("refs",&eref);
			mv->load(eref);
			BMessage	*m=new BMessage('Preq');
			m->AddInt8("edit_no",-1);
			BMessenger(((mkcal*)be_app)->cw->v).SendMessage(m);
		}break;
		case 'wcfg':{				//save config
			entry_ref	dir;
			const char	*name;
			msg->FindRef("directory",&dir);
			msg->FindString("name",&name);
			mv->save_config(dir,name);
			delete fp;fp=NULL;
		}break;
		case B_CANCEL:{				//load/save cansel
			delete fp;fp=NULL;
		}break;
		case 'slct':{
			eraseframe();
			if(sel_no<0){
				sel_now.f=false;
			}else{
				sel_now.f=true;
				sel_now.r=((object*)obl.ItemAt(sel_no))->r;
			}
			drawframe();
		}break;
		case 'draw':{
			mv->create_wallpaper();
			if(sel_no<0){
				sel_now.f=false;
			}else{
				sel_now.f=true;
				sel_now.r=((object*)obl.ItemAt(sel_no))->r;
			}
			Draw(scrn);
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void preview::drawframe()
{
	if(sel_now.f){
		SetDrawingMode(B_OP_INVERT);
		FillRect(BRect(sel_now.r.LeftTop()-BPoint(3,3),sel_now.r.LeftTop()+BPoint(3,3)));
		FillRect(BRect(sel_now.r.RightTop()-BPoint(3,3),sel_now.r.RightTop()+BPoint(3,3)));
		FillRect(BRect(sel_now.r.LeftBottom()-BPoint(3,3),sel_now.r.LeftBottom()+BPoint(3,3)));
		FillRect(BRect(sel_now.r.RightBottom()-BPoint(3,3),sel_now.r.RightBottom()+BPoint(3,3)));
		SetDrawingMode(B_OP_COPY);
	}
	sel_old=sel_now;
}

void preview::eraseframe()
{
	if(sel_old.f){
		SetDrawingMode(B_OP_INVERT);
		FillRect(BRect(sel_old.r.LeftTop()-BPoint(3,3),sel_old.r.LeftTop()+BPoint(3,3)));
		FillRect(BRect(sel_old.r.RightTop()-BPoint(3,3),sel_old.r.RightTop()+BPoint(3,3)));
		FillRect(BRect(sel_old.r.LeftBottom()-BPoint(3,3),sel_old.r.LeftBottom()+BPoint(3,3)));
		FillRect(BRect(sel_old.r.RightBottom()-BPoint(3,3),sel_old.r.RightBottom()+BPoint(3,3)));
		SetDrawingMode(B_OP_COPY);
		sel_old.f=false;
	}
}
//------------------------------------------------
configwindow::configwindow(BRect frame):BWindow(frame,"mkcal "VER,B_TITLED_WINDOW,B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
{
	BRect	fr(0,0,400,400);
	fr.OffsetTo(0,20);
	v=new configview(fr);
	AddChild(v);
	setupmenus();
	Show();
}

bool configwindow::QuitRequested()
{
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);//be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void configwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mi=new BMenuItem(_T("New"),new BMessage('fine'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Save as"),new BMessage('fiwr'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
/*
	 mi=new BMenuItem(_T("Print"),new BMessage('fipr'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
configview::configview(BRect frame):BView(frame,"configview",B_FOLLOW_ALL_SIDES,0)
{
	fp=NULL;
	sel_no=-1;
	conf_no=-1;
}

configview::~configview()
{
}

void configview::AttachedToWindow()
{
	rgb_color	vc={200,255,255,255};
	rgb_color	hc={0,0,0,255};
	rgb_color	lc={100,100,100,255};
	
	SetViewColor(vc);
	SetHighColor(hc);
	SetLowColor(lc);
	SetFont(be_bold_font);

	BMessage	*ms;
	BPopUpMenu	*pm;
	BStringView	*sv;
	char	s[16];
	*s=0;

	sv_sel_no=new BStringView(BRect(170,10,250,28),"sel_no","");
	sv_sel_no->SetAlignment(B_ALIGN_CENTER);
	AddChild(sv_sel_no);

	ms=new BMessage('Bhit');
	bt_back=new BButton(BRect(150,10,170,25),"back","<",ms);
	bt_back->SetFontSize(8);
	bt_back->SetTarget(this);
	AddChild(bt_back);

	ms=new BMessage('Bhit');
	bt_next=new BButton(BRect(250,10,270,25),"next",">",ms);
	bt_next->SetFontSize(8);
	bt_next->SetTarget(this);
	AddChild(bt_next);

	ms=new BMessage('Bhit');
	bt_add=new BButton(BRect(300,10,340,25),"add","add",ms);
	bt_add->SetFontSize(12);
	bt_add->SetTarget(this);
	AddChild(bt_add);

	ms=new BMessage('Bhit');
	bt_del=new BButton(BRect(350,10,390,25),"del","del",ms);
	bt_del->SetFontSize(12);
	bt_del->SetTarget(this);
	AddChild(bt_del);



	v_base=new BView(Bounds(),"config_base",0,B_WILL_DRAW);
	AddChild(v_base);
	v_base->SetViewColor(vc);			//v_base->SetColorsFromParent();

	rv_base_mode=new BView(BRect(30,50,370,120),"base_mode_gr",0,B_WILL_DRAW);
	v_base->AddChild(rv_base_mode);
	rv_base_mode->SetViewColor(vc);		//rv_base_mode->SetColorsFromParent();
	sv=new BStringView(BRect(0,0,70,18),"base_mode","base_type");
	rv_base_mode->AddChild(sv);
	ms=new BMessage('Vchg');
	rb_base_mode1=new BRadioButton(BRect(20,25,120,45),"mono","mono color",ms);
	rb_base_mode1->SetTarget(this);
	rv_base_mode->AddChild(rb_base_mode1);
	ms=new BMessage('Vchg');
	rb_base_mode2=new BRadioButton(BRect(120,25,220,45),"img_c","image (fit screen)",ms);
	rb_base_mode2->SetTarget(this);
	rv_base_mode->AddChild(rb_base_mode2);
	ms=new BMessage('Vchg');
	rb_base_mode3=new BRadioButton(BRect(220,25,320,45),"img_f","image (center)",ms);
	rb_base_mode3->SetTarget(this);
	rv_base_mode->AddChild(rb_base_mode3);
	ms=new BMessage('Vchg');
	rb_base_mode4=new BRadioButton(BRect(120,50,220,70),"img_p","image >>>",ms);
	rb_base_mode4->SetTarget(this);
	rv_base_mode->AddChild(rb_base_mode4);
	ms=new BMessage('Vchg');
	tc_bg_bounds=new BTextControl(BRect(220,50,320,70),"bg_bounds","",s,ms);
	tc_bg_bounds->SetDivider(0);
	tc_bg_bounds->SetTarget(this);
	rv_base_mode->AddChild(tc_bg_bounds);

	ms=new BMessage('Vchg');
	tc_base_col=new BTextControl(BRect(30,150,140,170),"base_col","base_color",s,ms);
	tc_base_col->SetTarget(this);
	v_base->AddChild(tc_base_col);
	sl_base_col=new rgbslider(BRect(140,150,370,170),"base_col",NULL,this,false,0);
	v_base->AddChild(sl_base_col);

	ms=new BMessage('timg');
	tc_base_fn=new BTextControl(BRect(30,200,310,220),"base_fn","base_image",s,ms);
	tc_base_fn->SetTarget(this);
	tc_base_fn->SetDivider(50);
	v_base->AddChild(tc_base_fn);
	ms=new BMessage('bimg');
	bt_search=new BButton(BRect(320,200,370,220),"search","search",ms);
	bt_search->SetFontSize(12);
	bt_search->SetTarget(this);
	v_base->AddChild(bt_search);


	pm=setupformatmenu();
	mf_outfmt=new BMenuField(BRect(30,250,280,270),"output_format","output_format",pm);
	mf_outfmt->SetDivider(70);
	v_base->AddChild(mf_outfmt);
	ms=new BMessage('Vchg');
	cb_auto=new BCheckBox(BRect(30,300,130,320),"auto","autoset",ms);
	cb_auto->SetTarget(this);
	v_base->AddChild(cb_auto);
	ms=new BMessage('Vchg');
	cb_textback=new BCheckBox(BRect(150,300,250,320),"textback","erase_textback",ms);
	cb_textback->SetTarget(this);
	v_base->AddChild(cb_textback);

	ms=new BMessage('Vchg');
	tc_scrn_col=new BTextControl(BRect(30,325,140,345),"screen_col","screen_color",s,ms);
	tc_scrn_col->SetTarget(this);
	v_base->AddChild(tc_scrn_col);
	sl_scrn_col=new rgbslider(BRect(140,325,370,345),"scrn_col",NULL,this,false,0);
	v_base->AddChild(sl_scrn_col);



	v_obj=new BView(Bounds(),"config_item",0,B_WILL_DRAW);
	AddChild(v_obj);
	v_obj->SetViewColor(vc);			//v_obj->SetColorsFromParent();

	ms=new BMessage('Vchg');
	tc_bounds=new BTextControl(BRect(20,50,180,70),"bounds","bounds",s,ms);
	tc_bounds->SetDivider(50);
	tc_bounds->SetTarget(this);
	v_obj->AddChild(tc_bounds);

	rv_cal_type=new BView(BRect(10,75,200,95),"cal_type_gr",0,B_WILL_DRAW);
	v_obj->AddChild(rv_cal_type);
	rv_cal_type->SetViewColor(vc);		//rv_cal_type->SetColorsFromParent();
	sv=new BStringView(BRect(0,0,40,16),"cal_type","calendar_type");
	rv_cal_type->AddChild(sv);
	ms=new BMessage('Vchg');
	rb_cal_type1=new BRadioButton(BRect(50,0,90,20),"day","day",ms);
	rb_cal_type1->SetTarget(this);
	rv_cal_type->AddChild(rb_cal_type1);
	ms=new BMessage('Vchg');
	rb_cal_type2=new BRadioButton(BRect(95,0,135,20),"month","month",ms);
	rb_cal_type2->SetTarget(this);
	rv_cal_type->AddChild(rb_cal_type2);
	ms=new BMessage('Vchg');
	rb_cal_type3=new BRadioButton(BRect(140,0,180,20),"year","year",ms);
	rb_cal_type3->SetTarget(this);
	rv_cal_type->AddChild(rb_cal_type3);

	ms=new BMessage('Vchg');
	tc_when=new BTextControl(BRect(20,100,120,120),"when","when",s,ms);
	tc_when->SetTarget(this);
	v_obj->AddChild(tc_when);

	rv_bg_type=new BView(BRect(200,75,390,95),"bg_type_gr",0,B_WILL_DRAW);
	v_obj->AddChild(rv_bg_type);
	rv_bg_type->SetViewColor(vc);		//rv_bg_type->SetColorsFromParent();
	sv=new BStringView(BRect(10,0,60,16),"bg_type","bg_type");
	rv_bg_type->AddChild(sv);
	ms=new BMessage('Vchg');
	rb_bg_type1=new BRadioButton(BRect(65,0,120,20),"bg_wall","wall",ms);
	rb_bg_type1->SetTarget(this);
	rv_bg_type->AddChild(rb_bg_type1);
	ms=new BMessage('Vchg');
	rb_bg_type2=new BRadioButton(BRect(125,0,180,20),"bg_bubble","bubble",ms);
	rb_bg_type2->SetTarget(this);
	rv_bg_type->AddChild(rb_bg_type2);

	ms=new BMessage('Vchg');
	tc_bg_col=new BTextControl(BRect(210,100,300,120),"bg_col","bg_color",s,ms);
	tc_bg_col->SetTarget(this);
	v_obj->AddChild(tc_bg_col);
	sl_bg_col=new rgbslider(BRect(300,100,390,120),"bg_col",NULL,this,true,0);
	v_obj->AddChild(sl_bg_col);


	pm=setupfontmenu(1);
	mf_year=new BMenuField(BRect(10,150,190,170),"year_font","year_font",pm);
	mf_year->SetDivider(50);
	v_obj->AddChild(mf_year);

	ms=new BMessage('Vchg');
	tc_year_size=new BTextControl(BRect(10,175,100,195),"year_size","year_size",s,ms);
	tc_year_size->SetTarget(this);
	v_obj->AddChild(tc_year_size);
	sl_year_size=new slider(BRect(100,175,190,195),"year_size",NULL,this,0,50,0);
	v_obj->AddChild(sl_year_size);

	ms=new BMessage('Vchg');
	tc_year_col=new BTextControl(BRect(10,200,100,220),"year_col","year_color",s,ms);
	tc_year_col->SetTarget(this);
	v_obj->AddChild(tc_year_col);
	sl_year_col=new rgbslider(BRect(100,200,190,220),"year_col",NULL,this,false,0);
	v_obj->AddChild(sl_year_col);

	rv_year_type=new BView(BRect(0,225,190,250),"year_type_gr",0,B_WILL_DRAW);
	v_obj->AddChild(rv_year_type);
	rv_year_type->SetViewColor(vc);	//rv_year_type->SetColorsFromParent();
//	sv=new BStringView(BRect(10,0,40,16),"year_type","type");
//	rv_year_type->AddChild(sv);
	ms=new BMessage('Vchg');
	rb_year_type1=new BRadioButton(BRect(15,0,55,20),"digit","digit",ms);
	rb_year_type1->SetTarget(this);
	rv_year_type->AddChild(rb_year_type1);
	ms=new BMessage('Vchg');
	rb_year_type2=new BRadioButton(BRect(60,0,100,20),"chinese","chinese",ms);
	rb_year_type2->SetTarget(this);
	rv_year_type->AddChild(rb_year_type2);
	ms=new BMessage('Vchg');
	rb_year_type3=new BRadioButton(BRect(105,0,145,20),"gengo","gengo",ms);
	rb_year_type3->SetTarget(this);
	rv_year_type->AddChild(rb_year_type3);


	pm=setupfontmenu(2);
	mf_month=new BMenuField(BRect(10,250,190,270),"month_font","month_font",pm);
	mf_month->SetDivider(50);
	v_obj->AddChild(mf_month);

	ms=new BMessage('Vchg');
	tc_month_size=new BTextControl(BRect(10,275,100,295),"month_size","month_size",s,ms);
	tc_month_size->SetTarget(this);
	v_obj->AddChild(tc_month_size);
	sl_month_size=new slider(BRect(100,275,190,295),"month_size",NULL,this,0,50,0);
	v_obj->AddChild(sl_month_size);

	ms=new BMessage('Vchg');
	tc_month_col=new BTextControl(BRect(10,300,100,320),"month_col","month_color",s,ms);
	tc_month_col->SetTarget(this);
	v_obj->AddChild(tc_month_col);
	sl_month_col=new rgbslider(BRect(100,300,190,320),"month_col",NULL,this,false,0);
	v_obj->AddChild(sl_month_col);

	rv_month_type=new BView(BRect(0,325,190,350),"month_type_gr",0,B_WILL_DRAW);
	v_obj->AddChild(rv_month_type);
	rv_month_type->SetViewColor(vc);	//rv_month_type->SetColorsFromParent();
//	sv=new BStringView(BRect(10,0,40,16),"month_type","type");
//	rv_month_type->AddChild(sv);
	ms=new BMessage('Vchg');
	rb_month_type1=new BRadioButton(BRect(15,0,55,20),"digit","digit",ms);
	rb_month_type1->SetTarget(this);
	rv_month_type->AddChild(rb_month_type1);
	ms=new BMessage('Vchg');
	rb_month_type2=new BRadioButton(BRect(60,0,100,20),"chinese","chinese",ms);
	rb_month_type2->SetTarget(this);
	rv_month_type->AddChild(rb_month_type2);
	ms=new BMessage('Vchg');
	rb_month_type3=new BRadioButton(BRect(105,0,145,20),"old","old",ms);
	rb_month_type3->SetTarget(this);
	rv_month_type->AddChild(rb_month_type3);
	ms=new BMessage('Vchg');
	rb_month_type4=new BRadioButton(BRect(150,0,190,20),"english","english",ms);
	rb_month_type4->SetTarget(this);
	rv_month_type->AddChild(rb_month_type4);


	pm=setupfontmenu(3);
	mf_day=new BMenuField(BRect(210,150,390,170),"day_font","day_font",pm);
	mf_day->SetDivider(50);
	v_obj->AddChild(mf_day);

	ms=new BMessage('Vchg');
	tc_day_size=new BTextControl(BRect(210,175,300,195),"day_size","day_size",s,ms);
	tc_day_size->SetTarget(this);
	v_obj->AddChild(tc_day_size);
	sl_day_size=new slider(BRect(300,175,390,195),"day_size",NULL,this,0,50,0);
	v_obj->AddChild(sl_day_size);

	ms=new BMessage('Vchg');
	tc_day_col=new BTextControl(BRect(210,200,300,220),"day_col","day_color",s,ms);
	tc_day_col->SetTarget(this);
	v_obj->AddChild(tc_day_col);
	sl_day_col=new rgbslider(BRect(300,200,390,220),"day_col",NULL,this,false,0);
	v_obj->AddChild(sl_day_col);

	ms=new BMessage('Vchg');
	tc_sun_col=new BTextControl(BRect(210,225,300,245),"sun_col","sun_color",s,ms);
	tc_sun_col->SetTarget(this);
	v_obj->AddChild(tc_sun_col);
	sl_sun_col=new rgbslider(BRect(300,225,390,245),"sun_col",NULL,this,false,0);
	v_obj->AddChild(sl_sun_col);

	ms=new BMessage('Vchg');
	tc_sat_col=new BTextControl(BRect(210,250,300,270),"sat_col","sat_color",s,ms);
	tc_sat_col->SetTarget(this);
	v_obj->AddChild(tc_sat_col);
	sl_sat_col=new rgbslider(BRect(300,250,390,270),"sat_col",NULL,this,false,0);
	v_obj->AddChild(sl_sat_col);

	ms=new BMessage('Vchg');
	tc_hol_col=new BTextControl(BRect(210,275,300,295),"holy_col","holy_color",s,ms);
	tc_hol_col->SetTarget(this);
	v_obj->AddChild(tc_hol_col);
	sl_hol_col=new rgbslider(BRect(300,275,390,295),"holy_col",NULL,this,false,0);
	v_obj->AddChild(sl_hol_col);

	rv_today_deco=new BView(BRect(210,300,400,325),"today_deco_gr",0,B_WILL_DRAW);
	v_obj->AddChild(rv_today_deco);
	rv_today_deco->SetViewColor(vc);	//rv_today_deco->SetColorsFromParent();
	sv=new BStringView(BRect(0,0,40,16),"today_deco","today_mark");
	rv_today_deco->AddChild(sv);
	ms=new BMessage('Vchg');
	rb_today_deco1=new BRadioButton(BRect(50,0,90,20),"mark_color","color",ms);
	rb_today_deco1->SetTarget(this);
	rv_today_deco->AddChild(rb_today_deco1);
	ms=new BMessage('Vchg');
	rb_today_deco2=new BRadioButton(BRect(95,0,135,20),"mark_reverse","reverse",ms);
	rb_today_deco2->SetTarget(this);
	rv_today_deco->AddChild(rb_today_deco2);
	ms=new BMessage('Vchg');
	rb_today_deco3=new BRadioButton(BRect(140,0,180,20),"mark_circle","circle",ms);
	rb_today_deco3->SetTarget(this);
	rv_today_deco->AddChild(rb_today_deco3);

	ms=new BMessage('Vchg');
	tc_today_col=new BTextControl(BRect(210,325,300,345),"mark_col","mark_color",s,ms);
	tc_today_col->SetTarget(this);
	v_obj->AddChild(tc_today_col);
	sl_today_col=new rgbslider(BRect(300,325,390,345),"mark_col",NULL,this,false,0);
	v_obj->AddChild(sl_today_col);


	MakeFocus();
	redraw(-1);
}

BPopUpMenu* configview::setupfontmenu(int mn)
{
	BPopUpMenu	*mf=new BPopUpMenu("");
	font	*f;
	for(int i=0;f=(font*)fontl.ItemAt(i);i++){
		char	s[256];
		sprintf(s,"%s(%s)",f->fam,f->sty);
		BMessage	*mes=new BMessage('Msel');
		mes->AddInt8("font_menu",mn);
		mes->AddInt16("font_no",i);
		BMenuItem	*mi=new BMenuItem(s,mes);
		mi->SetTarget(this);
		mf->AddItem(mi);
		if(mn==1)f->my=mi;
		if(mn==2)f->mm=mi;
		if(mn==3)f->md=mi;
	}
	mf->SetRadioMode(true);
	return(mf);
}

BPopUpMenu* configview::setupformatmenu()
{
	BPopUpMenu	*mf=new BPopUpMenu("");
	xlator	*xl;
	for(int i=0;xl=(xlator*)xlt.ItemAt(i);i++){
		char	s[256];
		sprintf(s,"%s",xl->mime);
		BMessage	*mes=new BMessage('Msel');
		mes->AddInt16("format_no",i);
		BMenuItem	*mi=new BMenuItem(s,mes);
		mi->SetTarget(this);
		mf->AddItem(mi);
		xl->m=mi;
	}
	mf->SetRadioMode(true);
	return(mf);
}

void configview::Draw(BRect rect)
{
}

void configview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'fine':{
			BMessenger(((mkcal*)be_app)->pw->v).SendMessage('aclr');
		}break;
		case 'fiop':{
			if(fp==NULL){
				BMessage	*m=new BMessage('rcfg');
				BMessenger	*mgr=new BMessenger(((mkcal*)be_app)->pw->v);
				fp=new BFilePanel(B_OPEN_PANEL,mgr,NULL,B_FILE_NODE,false,m);
				fp->Window()->SetTitle("load config");
				fp->Show();
			}
		}break;
		case 'fiwr':{
			if(fp==NULL){
				BMessage	*m=new BMessage('wcfg');
				BMessenger	*mgr=new BMessenger(((mkcal*)be_app)->pw->v);
				fp=new BFilePanel(B_SAVE_PANEL,mgr,NULL,B_FILE_NODE,false,m);
				fp->Window()->SetTitle("save config");
				fp->Show();
			}
		}break;
		case 'fipr':{				//printout
/*
			if(bm){
				BPrintJob	prt("mkcal");
				prt.ConfigPage();
				prt.ConfigJob();
				BRect		pr=prt.PrintableRect();
				prt.BeginJob();
				prt.DrawView(this,pr,BPoint(0,0));
				prt.SpoolPage();
				prt.CommitJob();
			}
*/
		}break;

		case 'Preq':{	//request from preview (select,move,load...n=-1)
			int8	n;
			if(msg->FindInt8("edit_no",&n))break;
			redraw(n);
//printf("sendmes : configv > preview\n");
			BMessenger(((mkcal*)be_app)->pw->v).SendMessage('draw');
		}break;
		case 'Msel':{
			void	*from;
			if(msg->FindPointer("source",&from))break;

			int8	mn;
			if(msg->FindInt8("font_menu",&mn))mn=-1;
			int16	fn;
			msg->FindInt16("font_no",&fn);
			int16	fmt;
			if(msg->FindInt16("format_no",&fmt))fmt=-1;
//			void	*src;
//			msg->FindPointer("source",&src);
//			int32	idx;
//			msg->FindInt32("index",&idx);
			char	s[256];
			strcpy(s,((BMenuItem*)from)->Label());
			char	*sp=s+strlen(s);
			*(--sp)=0;
			while(*(--sp)!='(');
			*(sp++)=0;
//printf("#%d-[%s][%s]\n",mn,s,sp);
			if(mn>=0){
				object	*o=(object*)obl.ItemAt(conf_no);
				if(mn==1){strcpy(o->year_fontf,s);strcpy(o->year_fonts,sp);o->year_font=fn;}
				if(mn==2){strcpy(o->month_fontf,s);strcpy(o->month_fonts,sp);o->month_font=fn;}
				if(mn==3){strcpy(o->day_fontf,s);strcpy(o->day_fonts,sp);o->day_font=fn;}
				BMessenger(((mkcal*)be_app)->pw->v).SendMessage('draw');
			}
			if(fmt>=0)outfmt=fmt;
//printf("sendmes : configv > preview\n");
		}break;
		case 'Vchg':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			int32	i32;
			if(from==cb_auto){
				msg->FindInt32("be:value",&i32);
				autoset=i32;
				break;
			}
			if(from==cb_textback){
				msg->FindInt32("be:value",&i32);
				textback=i32;
				break;
			}
			if(from==tc_bg_bounds){
				int32	i1,i2,i3,i4;
				sscanf(tc_bg_bounds->Text(),"%d,%d,%d,%d",&i1,&i2,&i3,&i4);
				bg_bounds=BRect(i1,i2,i3,i4);
			}
			if(from==tc_bounds){
				int32	i1,i2,i3,i4;
				sscanf(tc_bounds->Text(),"%d,%d,%d,%d",&i1,&i2,&i3,&i4);
				((object*)obl.ItemAt(conf_no))->r=BRect(i1,i2,i3,i4);
			}
			if(from==tc_when){
				sscanf(tc_when->Text(),"%d",&i32);
				((object*)obl.ItemAt(conf_no))->when=i32;
			}
			if(from==tc_scrn_col){
				sscanf(tc_scrn_col->Text(),"%x",&i32);
				scrn_color=i32;
				sl_scrn_col->SetValue(i32);
				break;
			}
			if(from==tc_base_col){
				sscanf(tc_base_col->Text(),"%x",&i32);
				base_color=i32;
				sl_base_col->SetValue(i32);
			}
			if(from==tc_bg_col){
				sscanf(tc_bg_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->bgcolor=i32;
				sl_bg_col->SetValue(i32);
			}
			if(from==tc_year_col){
				sscanf(tc_year_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->year_color=i32;
				sl_year_col->SetValue(i32);
			}
			if(from==tc_month_col){
				sscanf(tc_month_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->month_color=i32;
				sl_month_col->SetValue(i32);
			}
			if(from==tc_day_col){
				sscanf(tc_day_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->day_color=i32;
				sl_day_col->SetValue(i32);
			}
			if(from==tc_sun_col){
				sscanf(tc_sun_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->sun_color=i32;
				sl_sun_col->SetValue(i32);
			}
			if(from==tc_sat_col){
				sscanf(tc_sat_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->sat_color=i32;
				sl_sat_col->SetValue(i32);
			}
			if(from==tc_hol_col){
				sscanf(tc_hol_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->hol_color=i32;
				sl_hol_col->SetValue(i32);
			}
			if(from==tc_today_col){
				sscanf(tc_today_col->Text(),"%x",&i32);
				((object*)obl.ItemAt(conf_no))->today_color=i32;
				sl_today_col->SetValue(i32);
			}
			if(from==tc_year_size){
				sscanf(tc_year_size->Text(),"%d",&i32);
				((object*)obl.ItemAt(conf_no))->year_size=i32;
				sl_year_size->SetValue(i32);
			}
			if(from==tc_month_size){
				sscanf(tc_month_size->Text(),"%d",&i32);
				((object*)obl.ItemAt(conf_no))->month_size=i32;
				sl_month_size->SetValue(i32);
			}
			if(from==tc_day_size){
				sscanf(tc_day_size->Text(),"%d",&i32);
				((object*)obl.ItemAt(conf_no))->day_size=i32;
				sl_day_size->SetValue(i32);
			}
			if(from==rb_base_mode1)base_mode=0;
			if(from==rb_base_mode2)base_mode=1;
			if(from==rb_base_mode3)base_mode=2;
			if(from==rb_base_mode4)base_mode=3;
			if(from==rb_bg_type1){
				((object*)obl.ItemAt(conf_no))->bgtype=0;
			}
			if(from==rb_bg_type2){
				((object*)obl.ItemAt(conf_no))->bgtype=1;
			}
			if(from==rb_cal_type1){
				((object*)obl.ItemAt(conf_no))->type=0;
				redraw();
			}
			if(from==rb_cal_type2){
				((object*)obl.ItemAt(conf_no))->type=10;
				redraw();
			}
			if(from==rb_cal_type3){
				((object*)obl.ItemAt(conf_no))->type=20;
				redraw();
			}
			if(from==rb_year_type1){
				((object*)obl.ItemAt(conf_no))->year_type=0;
			}
			if(from==rb_year_type2){
				((object*)obl.ItemAt(conf_no))->year_type=1;
			}
			if(from==rb_year_type3){
				((object*)obl.ItemAt(conf_no))->year_type=2;
			}
			if(from==rb_month_type1){
				((object*)obl.ItemAt(conf_no))->month_type=0;
			}
			if(from==rb_month_type2){
				((object*)obl.ItemAt(conf_no))->month_type=1;
			}
			if(from==rb_month_type3){
				((object*)obl.ItemAt(conf_no))->month_type=2;
			}
			if(from==rb_month_type4){
				((object*)obl.ItemAt(conf_no))->month_type=3;
			}
			if(from==rb_today_deco1){
				((object*)obl.ItemAt(conf_no))->today_deco=0;
			}
			if(from==rb_today_deco2){
				((object*)obl.ItemAt(conf_no))->today_deco=1;
			}
			if(from==rb_today_deco3){
				((object*)obl.ItemAt(conf_no))->today_deco=2;
			}
//printf("sendmes : configv > preview\n");
			BMessenger(((mkcal*)be_app)->pw->v).SendMessage('draw');
		}break;
		case 'Smov':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			float	sz;
			msg->FindFloat("value",&sz);
			int32	rgb;
			msg->FindInt32("argb",&rgb);
			char	s[16];
			if(from==sl_year_size){
				((object*)obl.ItemAt(conf_no))->year_size=(int)sz;
				sprintf(s,"%d",(int)sz);
				tc_year_size->SetText(s);
			}
			if(from==sl_month_size){
				((object*)obl.ItemAt(conf_no))->month_size=(int)sz;
				sprintf(s,"%d",(int)sz);
				tc_month_size->SetText(s);
			}
			if(from==sl_day_size){
				((object*)obl.ItemAt(conf_no))->day_size=(int)sz;
				sprintf(s,"%d",(int)sz);
				tc_day_size->SetText(s);
			}
			if(from==sl_scrn_col){
				scrn_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_scrn_col->SetText(s);
				break;
			}
			if(from==sl_base_col){
				base_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_base_col->SetText(s);
			}
			if(from==sl_bg_col){
				((object*)obl.ItemAt(conf_no))->bgcolor=rgb;
				sprintf(s,"%08x",rgb);
				tc_bg_col->SetText(s);
			}
			if(from==sl_year_col){
				((object*)obl.ItemAt(conf_no))->year_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_year_col->SetText(s);
			}
			if(from==sl_month_col){
				((object*)obl.ItemAt(conf_no))->month_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_month_col->SetText(s);
			}
			if(from==sl_day_col){
				((object*)obl.ItemAt(conf_no))->day_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_day_col->SetText(s);
			}
			if(from==sl_sun_col){
				((object*)obl.ItemAt(conf_no))->sun_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_sun_col->SetText(s);
			}
			if(from==sl_sat_col){
				((object*)obl.ItemAt(conf_no))->sat_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_sat_col->SetText(s);
			}
			if(from==sl_hol_col){
				((object*)obl.ItemAt(conf_no))->hol_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_hol_col->SetText(s);
			}
			if(from==sl_today_col){
				((object*)obl.ItemAt(conf_no))->today_color=rgb;
				sprintf(s,"%06x",rgb);
				tc_today_col->SetText(s);
			}
//printf("sendmes : configv > preview\n");
			BMessenger(((mkcal*)be_app)->pw->v).SendMessage('draw');
		}break;
		case 'Bhit':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			int	c=obl.CountItems();
			int	no=conf_no;
			int	f=0;
			if(c){
				if(from==bt_back)no=no<0?c-1:no-1;
				if(from==bt_next)no=no<c-1?no+1:-1;
			}else no=-1;			
			if(no!=conf_no)f=1;
			if((no>=0)&&(from==bt_del)){
				object	*o=(object*)obl.ItemAt(no);
				obl.RemoveItem(no);
				delete o;
				no=-1;
				f=2;
			}
			if(from==bt_add){
				object	*o;
				if(no<0)o=new object();else o=new object((object*)obl.ItemAt(no));
				obl.AddItem(o,++no);
				f=2;
			}
			if(f){
				redraw(no);
				sel_no=no;
//printf("sendmes : configv > preview\n");
				BMessenger(((mkcal*)be_app)->pw->v).SendMessage(f==1?'slct':'draw');
			}
			break;
		}break;
		case 'bimg':{
			if(fp==NULL){
				BMessage	*m=new BMessage('rimg');
				BMessenger	*mgr=new BMessenger(((mkcal*)be_app)->pw->v);
				fp=new BFilePanel(B_OPEN_PANEL,mgr,NULL,B_FILE_NODE,false,m);
				fp->Window()->SetTitle("select base-image");
				fp->Show();
			}
		}break;
		case 'timg':{
			entry_ref	eref;
			if(get_ref_for_path(tc_base_fn->Text(),&eref))break;
			BMessage	*m=new BMessage('rimg');
			m->AddRef("refs",&eref);
			BMessenger(((mkcal*)be_app)->pw->v).SendMessage(m);
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void configview::redraw(int no)
{
	static bool	f_base=true;				//true..show  false..hide
	static bool	f_obj=true;					//true..show  false..hide
	if(no>=-1)conf_no=no;
	object	*o=(object*)obl.ItemAt(conf_no);
	char	s[32];
	uchar	fb,fo,fy,fm,fd;
	bool	f;
	if(o){
		sprintf(s,"item no.%d\n",conf_no+1);
		sv_sel_no->SetText(s);
		fo=0xff;
		if(o->type==0){fy=fm=0;fd=0x07;}
		if(o->type==10){fy=0x0f;fm=0x0f;fd=0xff;}
		if(o->type==20){fy=0x07;fm=0x07;fd=0xff;}
		if(f_base){v_base->Hide();f_base=false;}	//	while(!v_base->IsHidden())v_base->Hide();
		if(!f_obj){v_obj->Show();f_obj=true;}		//	while(v_obj->IsHidden())v_obj->Show();

		if(f=fo&0x01){
			sprintf(s,"%d,%d,%d,%d",(int)o->r.left,(int)o->r.top,(int)o->r.right,(int)o->r.bottom);
			tc_bounds->SetText(s);
		};tc_bounds->SetEnabled(f);
		if(f=fo&0x02){
			rb_bg_type1->SetValue(o->bgtype==0);
			rb_bg_type2->SetValue(o->bgtype==1);
		};rb_bg_type1->SetEnabled(f);rb_bg_type2->SetEnabled(f);
		if(f=fo&0x04){
			sprintf(s,"%08x",o->bgcolor);
			tc_bg_col->SetText(s);
			sl_bg_col->SetValue(o->bgcolor);
		};tc_bg_col->SetEnabled(f);
		if(f=fo&0x08){
			rb_cal_type1->SetValue(o->type==0);
			rb_cal_type2->SetValue(o->type==10);
			rb_cal_type3->SetValue(o->type==20);
		};rb_cal_type1->SetEnabled(f);rb_cal_type2->SetEnabled(f);rb_cal_type3->SetEnabled(f);
		if(f=fo&0x10){
			sprintf(s,"%d",o->when);
			tc_when->SetText(s);
		};tc_when->SetEnabled(f);

		if(f=fy&0x01){
			((font*)fontl.ItemAt(o->year_font))->my->SetMarked(true);
		};mf_year->SetEnabled(f);
		if(f=fy&0x02){
			sprintf(s,"%d",o->year_size);
			tc_year_size->SetText(s);
			sl_year_size->SetValue(o->year_size);
		};tc_year_size->SetEnabled(f);
		if(f=fy&0x04){
			sprintf(s,"%06x",o->year_color);
			tc_year_col->SetText(s);
			sl_year_col->SetValue(o->year_color);
		};tc_year_col->SetEnabled(f);
		if(f=fy&0x08){
			rb_year_type1->SetValue(o->year_type==0);
			rb_year_type2->SetValue(o->year_type==1);
			rb_year_type3->SetValue(o->year_type==2);
		};rb_year_type1->SetEnabled(f);rb_year_type2->SetEnabled(f);rb_year_type3->SetEnabled(f);

		if(f=fm&0x01){
			((font*)fontl.ItemAt(o->month_font))->mm->SetMarked(true);
		};mf_month->SetEnabled(f);
		if(f=fm&0x02){
			sprintf(s,"%d",o->month_size);
			tc_month_size->SetText(s);
			sl_month_size->SetValue(o->month_size);
		};tc_month_size->SetEnabled(f);
		if(f=fm&0x04){
			sprintf(s,"%06x",o->month_color);
			tc_month_col->SetText(s);
			sl_month_col->SetValue(o->month_color);
		};tc_month_col->SetEnabled(f);
		if(f=fm&0x08){
			rb_month_type1->SetValue(o->month_type==0);
			rb_month_type2->SetValue(o->month_type==1);
			rb_month_type3->SetValue(o->month_type==2);
			rb_month_type4->SetValue(o->month_type==3);
		};rb_month_type1->SetEnabled(f);rb_month_type2->SetEnabled(f);rb_month_type3->SetEnabled(f);rb_month_type4->SetEnabled(f);

		if(f=fd&0x01){
			((font*)fontl.ItemAt(o->day_font))->md->SetMarked(true);
		};mf_day->SetEnabled(f);
		if(f=fd&0x02){
			sprintf(s,"%d",o->day_size);
			tc_day_size->SetText(s);
			sl_day_size->SetValue(o->day_size);
		};tc_day_size->SetEnabled(f);
		if(f=fd&0x04){
			sprintf(s,"%06x",o->day_color);
			tc_day_col->SetText(s);
			sl_day_col->SetValue(o->day_color);
		};tc_day_col->SetEnabled(f);
		if(f=fd&0x08){
			sprintf(s,"%06x",o->sun_color);
			tc_sun_col->SetText(s);
			sl_sun_col->SetValue(o->sun_color);
		};tc_sun_col->SetEnabled(f);
		if(f=fd&0x10){
			sprintf(s,"%06x",o->sat_color);
			tc_sat_col->SetText(s);
			sl_sat_col->SetValue(o->sat_color);
		};tc_sat_col->SetEnabled(f);
		if(f=fd&0x20){
			sprintf(s,"%06x",o->hol_color);
			tc_hol_col->SetText(s);
			sl_hol_col->SetValue(o->hol_color);
		};tc_hol_col->SetEnabled(f);

		if(f=fd&0x40){
			rb_today_deco1->SetValue(o->today_deco==0);
			rb_today_deco2->SetValue(o->today_deco==1);
			rb_today_deco3->SetValue(o->today_deco==2);
		};rb_today_deco1->SetEnabled(f);rb_today_deco2->SetEnabled(f);rb_today_deco3->SetEnabled(f);
		if(f=fd&0x80){
			sprintf(s,"%06x",o->today_color);
			tc_today_col->SetText(s);
			sl_today_col->SetValue(o->today_color);
		};tc_today_col->SetEnabled(f);
	}else{
		sv_sel_no->SetText("base / output");
		fb=0xff;
		if(f_obj){v_obj->Hide();f_obj=false;}		//	while(!v_obj->IsHidden())v_obj->Hide();
		if(!f_base){v_base->Show();f_base=true;}	//	while(v_base->IsHidden())v_base->Show();

		if(f=fb&0x01){
			rb_base_mode1->SetValue(base_mode==0);
			rb_base_mode2->SetValue(base_mode==1);
			rb_base_mode3->SetValue(base_mode==2);
			rb_base_mode4->SetValue(base_mode==3);
		};rb_base_mode1->SetEnabled(f);rb_base_mode2->SetEnabled(f);rb_base_mode3->SetEnabled(f);rb_base_mode4->SetEnabled(f);
		if(f=fb&0x02){
			sprintf(s,"%d,%d,%d,%d",(int)bg_bounds.left,(int)bg_bounds.top,(int)bg_bounds.right,(int)bg_bounds.bottom);
			tc_bg_bounds->SetText(s);
		};tc_bounds->SetEnabled(f);
		if(f=fb&0x04){
			sprintf(s,"%06x",base_color);
			tc_base_col->SetText(s);
			sl_base_col->SetValue(base_color);
		};tc_base_col->SetEnabled(f);
		if(f=fb&0x08){
			tc_base_fn->SetText(baseimgpath);
		};tc_base_fn->SetEnabled(f);
		if(f=fb&0x10){
			((xlator*)xlt.ItemAt(outfmt))->m->SetMarked(true);
		};mf_outfmt->SetEnabled(f);
		if(f=fb&0x20){
			cb_auto->SetValue(autoset);
		};cb_auto->SetEnabled(f);
		if(f=fb&0x40){
			cb_textback->SetValue(textback);
		};cb_textback->SetEnabled(f);
		if(f=fb&0x80){
			sprintf(s,"%06x",scrn_color);
			tc_scrn_col->SetText(s);
			sl_scrn_col->SetValue(scrn_color);
		};tc_scrn_col->SetEnabled(f);
	}
}
//------------------------------------------------
object::object(object *src)
{
	if(src){
		strcpy(year_fontf,src->year_fontf);strcpy(year_fonts,src->year_fonts);
		strcpy(month_fontf,src->month_fontf);strcpy(month_fonts,src->month_fonts);
		strcpy(day_fontf,src->day_fontf);strcpy(day_fonts,src->day_fonts);
		year_font=src->year_font;
		month_font=src->month_font;
		day_font=src->day_font;
//		r=src->r+BPoint(50,50);
		r=BRect(src->r.left+50,src->r.top+50,src->r.right+50,src->r.bottom+50);

		type=src->type;
		when=src->when;
		bgtype=src->bgtype;
		bgcolor=src->bgcolor;
		year_color=src->year_color;
		month_color=src->month_color;
		day_color=src->day_color;
		sun_color=src->sun_color;
		sat_color=src->sat_color;
		hol_color=src->hol_color;
		today_color=src->today_color;
		year_size=src->year_size;
		month_size=src->month_size;
		day_size=src->day_size;
		year_type=src->year_type;
		month_type=src->month_type;
		today_deco=src->today_deco;
	}else{
		font	ftd;
		be_plain_font->GetFamilyAndStyle(&ftd.fam,&ftd.sty);
		strcpy(year_fontf,ftd.fam);strcpy(year_fonts,ftd.sty);
		strcpy(month_fontf,ftd.fam);strcpy(month_fonts,ftd.sty);
		strcpy(day_fontf,ftd.fam);strcpy(day_fonts,ftd.sty);
		year_font=month_font=day_font=dfn;

		r=BRect(scrn.right/4,scrn.bottom/4,scrn.right*3/4,scrn.bottom*3/4);
		type=10;
		when=0;
		bgtype=0;
		bgcolor=0xffffffff;
		year_color=0x000000;
		month_color=0x000000;
		day_color=0x000000;
		sun_color=0xff0000;
		sat_color=0x0000ff;
		hol_color=0xff8800;
		today_color=0x00aa00;
		year_size=0;
		month_size=0;
		day_size=0;
		year_type=0;
		month_type=0;
		today_deco=0;
	}
}
